/*!
  * jskos-tools v1.0.43
  * Copyright (c) 2018 Verbundzentrale des GBV (VZG)
  * @license MIT
  */
var jskos = (() => {
  var __defProp = Object.defineProperty;
  var __defProps = Object.defineProperties;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getOwnPropSymbols = Object.getOwnPropertySymbols;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __propIsEnum = Object.prototype.propertyIsEnumerable;
  var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
  var __spreadValues = (a, b) => {
    for (var prop in b || (b = {}))
      if (__hasOwnProp.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    if (__getOwnPropSymbols)
      for (var prop of __getOwnPropSymbols(b)) {
        if (__propIsEnum.call(b, prop))
          __defNormalProp(a, prop, b[prop]);
      }
    return a;
  };
  var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
  var __export = (target, all) => {
    for (var name in all)
      __defProp(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames(from))
        if (!__hasOwnProp.call(to, key) && key !== except)
          __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

  // src/index.js
  var src_exports = {};
  __export(src_exports, {
    ConceptScheme: () => concept_scheme_default,
    addContext: () => addContext,
    addMappingIdentifiers: () => addMappingIdentifiers,
    annotationCreatorMatches: () => annotationCreatorMatches,
    annotationCreatorName: () => annotationCreatorName,
    annotationCreatorUri: () => annotationCreatorUri,
    clean: () => clean,
    cleanJSKOS: () => cleanJSKOS,
    compare: () => compare2,
    compareConcepts: () => compareConcepts,
    compareFunctions: () => compareFunctions,
    compareMappingContent: () => compareMappingContent,
    compareMappingMembers: () => compareMappingMembers,
    compareMappings: () => compareMappings,
    compareMappingsDeep: () => compareMappingsDeep,
    compareObjects: () => compareObjects,
    compareSchemes: () => compareSchemes,
    conceptsOfMapping: () => conceptsOfMapping,
    copyDeep: () => copyDeep,
    deepCopy: () => deepCopy,
    default: () => src_default,
    defaultMappingType: () => defaultMappingType,
    definition: () => definition,
    flattenMapping: () => flattenMapping,
    getAllUris: () => getAllUris,
    guessObjectType: () => guessObjectType,
    guessSchemeFromNotation: () => guessSchemeFromNotation,
    isConcept: () => isConcept,
    isContainedIn: () => isContainedIn,
    isScheme: () => isScheme,
    isSchemeInList: () => isSchemeInList,
    isValidUri: () => isValidUri,
    languageMapContent: () => languageMapContent,
    languagePreference: () => language_preference_default,
    mappingCSV: () => mappingCSV,
    mappingContent: () => mappingContent,
    mappingContentIdentifier: () => mappingContentIdentifier,
    mappingMembers: () => mappingMembers,
    mappingMembersIdentifier: () => mappingMembersIdentifier,
    mappingRegistryIsStored: () => mappingRegistryIsStored,
    mappingTypeByType: () => mappingTypeByType,
    mappingTypeByUri: () => mappingTypeByUri,
    mappingTypes: () => mapping_types_default,
    matchObjectTypes: () => matchObjectTypes,
    merge: () => merge,
    mergeUris: () => mergeUris,
    minifyMapping: () => minifyMapping,
    normalize: () => normalize,
    notation: () => notation,
    objectTypes: () => objectTypes,
    prefLabel: () => prefLabel,
    sortConcepts: () => sortConcepts,
    sortSchemes: () => sortSchemes,
    userOwnsMapping: () => userOwnsMapping
  });

  // src/identifiers.js
  var identifiers_exports = {};
  __export(identifiers_exports, {
    addMappingIdentifiers: () => addMappingIdentifiers,
    compareMappingContent: () => compareMappingContent,
    compareMappingMembers: () => compareMappingMembers,
    compareMappings: () => compareMappings,
    mappingContent: () => mappingContent,
    mappingContentIdentifier: () => mappingContentIdentifier,
    mappingMembers: () => mappingMembers,
    mappingMembersIdentifier: () => mappingMembersIdentifier
  });

  // src/sha1.js
  function sha1(str) {
    var _rotLeft = function(n, s) {
      var t4 = n << s | n >>> 32 - s;
      return t4;
    };
    var _cvtHex = function(val) {
      var str2 = "";
      var i2;
      var v;
      for (i2 = 7; i2 >= 0; i2--) {
        v = val >>> i2 * 4 & 15;
        str2 += v.toString(16);
      }
      return str2;
    };
    var blockstart;
    var i, j;
    var W = new Array(80);
    var H0 = 1732584193;
    var H1 = 4023233417;
    var H2 = 2562383102;
    var H3 = 271733878;
    var H4 = 3285377520;
    var A, B, C, D, E;
    var temp;
    str = unescape(encodeURIComponent(str));
    var strLen = str.length;
    var wordArray = [];
    for (i = 0; i < strLen - 3; i += 4) {
      j = str.charCodeAt(i) << 24 | str.charCodeAt(i + 1) << 16 | str.charCodeAt(i + 2) << 8 | str.charCodeAt(i + 3);
      wordArray.push(j);
    }
    switch (strLen % 4) {
      case 0:
        i = 2147483648;
        break;
      case 1:
        i = str.charCodeAt(strLen - 1) << 24 | 8388608;
        break;
      case 2:
        i = str.charCodeAt(strLen - 2) << 24 | str.charCodeAt(strLen - 1) << 16 | 32768;
        break;
      case 3:
        i = str.charCodeAt(strLen - 3) << 24 | str.charCodeAt(strLen - 2) << 16 | str.charCodeAt(strLen - 1) << 8 | 128;
        break;
    }
    wordArray.push(i);
    while (wordArray.length % 16 !== 14) {
      wordArray.push(0);
    }
    wordArray.push(strLen >>> 29);
    wordArray.push(strLen << 3 & 4294967295);
    for (blockstart = 0; blockstart < wordArray.length; blockstart += 16) {
      for (i = 0; i < 16; i++) {
        W[i] = wordArray[blockstart + i];
      }
      for (i = 16; i <= 79; i++) {
        W[i] = _rotLeft(W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16], 1);
      }
      A = H0;
      B = H1;
      C = H2;
      D = H3;
      E = H4;
      for (i = 0; i <= 19; i++) {
        temp = _rotLeft(A, 5) + (B & C | ~B & D) + E + W[i] + 1518500249 & 4294967295;
        E = D;
        D = C;
        C = _rotLeft(B, 30);
        B = A;
        A = temp;
      }
      for (i = 20; i <= 39; i++) {
        temp = _rotLeft(A, 5) + (B ^ C ^ D) + E + W[i] + 1859775393 & 4294967295;
        E = D;
        D = C;
        C = _rotLeft(B, 30);
        B = A;
        A = temp;
      }
      for (i = 40; i <= 59; i++) {
        temp = _rotLeft(A, 5) + (B & C | B & D | C & D) + E + W[i] + 2400959708 & 4294967295;
        E = D;
        D = C;
        C = _rotLeft(B, 30);
        B = A;
        A = temp;
      }
      for (i = 60; i <= 79; i++) {
        temp = _rotLeft(A, 5) + (B ^ C ^ D) + E + W[i] + 3395469782 & 4294967295;
        E = D;
        D = C;
        C = _rotLeft(B, 30);
        B = A;
        A = temp;
      }
      H0 = H0 + A & 4294967295;
      H1 = H1 + B & 4294967295;
      H2 = H2 + C & 4294967295;
      H3 = H3 + D & 4294967295;
      H4 = H4 + E & 4294967295;
    }
    temp = _cvtHex(H0) + _cvtHex(H1) + _cvtHex(H2) + _cvtHex(H3) + _cvtHex(H4);
    return temp.toLowerCase();
  }

  // src/identifiers.js
  function reduceSet(set) {
    return set.map((member) => member && member.uri).filter(Boolean);
  }
  function memberField(bundle) {
    return ["memberSet", "memberList", "memberChoice"].find((f) => bundle[f]);
  }
  function reduceBundle(bundle) {
    const field = memberField(bundle);
    const set = bundle[field] ? reduceSet(bundle[field]) : [];
    return {
      [set.length > 1 ? field : "memberSet"]: set.map((uri) => ({ uri }))
    };
  }
  function mappingContent(mapping) {
    const { from, to, type } = mapping;
    let result = {
      from: reduceBundle(from || {}),
      to: reduceBundle(to || {}),
      type: [
        type && type[0] || "http://www.w3.org/2004/02/skos/core#mappingRelation"
      ]
    };
    for (let side of ["from", "to"]) {
      if ((result[side][memberField(result[side])] || []).length == 0) {
        let scheme = mapping[side + "Scheme"];
        if (scheme && scheme.uri) {
          result[side + "Scheme"] = { uri: scheme.uri };
        }
      }
    }
    return result;
  }
  function mappingMembers(mapping) {
    const { from, to } = mapping;
    const memberUris = [from, to].filter(Boolean).map((bundle) => reduceSet(bundle[memberField(bundle)] || []));
    return [].concat(...memberUris).sort();
  }
  function mappingContentIdentifier(mapping) {
    const json = JSON.stringify(mappingContent(mapping), ["from", "fromScheme", "to", "toScheme", "type", "memberSet", "memberList", "memberChoice", "uri"]);
    return "urn:jskos:mapping:content:" + sha1(json + "\n");
  }
  function mappingMembersIdentifier(mapping) {
    const json = JSON.stringify(mappingMembers(mapping));
    return "urn:jskos:mapping:members:" + sha1(json + "\n");
  }
  function addMappingIdentifiers(mapping) {
    const identifier = (mapping.identifier || []).filter(
      (id) => id && !id.startsWith("urn:jskos:mapping:")
    ).concat([
      mappingMembersIdentifier(mapping),
      mappingContentIdentifier(mapping)
    ]).sort();
    return Object.assign({}, mapping, { identifier });
  }
  function compare(mapping1, mapping2, prefix) {
    mapping1 = mapping1 && addMappingIdentifiers(mapping1);
    mapping2 = mapping2 && addMappingIdentifiers(mapping2);
    let id1 = mapping1 && mapping1.identifier ? mapping1.identifier.find((element) => element.startsWith(prefix)) : null;
    let id2 = mapping2 && mapping2.identifier ? mapping2.identifier.find((element) => element.startsWith(prefix)) : null;
    return id1 == id2;
  }
  function compareMappings(mapping1, mapping2) {
    return compare(mapping1, mapping2, "urn:jskos:mapping:content:");
  }
  var compareMappingContent = compareMappings;
  function compareMappingMembers(mapping1, mapping2) {
    return compare(mapping1, mapping2, "urn:jskos:mapping:members:");
  }

  // src/tools.js
  var tools_exports = {};
  __export(tools_exports, {
    addContext: () => addContext,
    annotationCreatorMatches: () => annotationCreatorMatches,
    annotationCreatorName: () => annotationCreatorName,
    annotationCreatorUri: () => annotationCreatorUri,
    clean: () => clean,
    cleanJSKOS: () => cleanJSKOS,
    compare: () => compare2,
    compareConcepts: () => compareConcepts,
    compareFunctions: () => compareFunctions,
    compareMappingsDeep: () => compareMappingsDeep,
    compareObjects: () => compareObjects,
    compareSchemes: () => compareSchemes,
    conceptsOfMapping: () => conceptsOfMapping,
    copyDeep: () => copyDeep,
    deepCopy: () => deepCopy,
    defaultMappingType: () => defaultMappingType,
    definition: () => definition,
    flattenMapping: () => flattenMapping,
    getAllUris: () => getAllUris,
    guessObjectType: () => guessObjectType,
    guessSchemeFromNotation: () => guessSchemeFromNotation,
    isConcept: () => isConcept,
    isContainedIn: () => isContainedIn,
    isScheme: () => isScheme,
    isSchemeInList: () => isSchemeInList,
    isValidUri: () => isValidUri,
    languageMapContent: () => languageMapContent,
    mappingCSV: () => mappingCSV,
    mappingRegistryIsStored: () => mappingRegistryIsStored,
    mappingTypeByType: () => mappingTypeByType,
    mappingTypeByUri: () => mappingTypeByUri,
    mappingTypes: () => mapping_types_default,
    matchObjectTypes: () => matchObjectTypes,
    merge: () => merge,
    mergeUris: () => mergeUris,
    minifyMapping: () => minifyMapping,
    normalize: () => normalize,
    notation: () => notation,
    objectTypes: () => objectTypes,
    prefLabel: () => prefLabel,
    sortConcepts: () => sortConcepts,
    sortSchemes: () => sortSchemes,
    userOwnsMapping: () => userOwnsMapping
  });

  // src/utils.js
  function isEqualWith(a, b, compare3) {
    const pSlice = Array.prototype.slice;
    const Object_keys = typeof Object.keys === "function" ? Object.keys : function(obj) {
      const keys = [];
      for (const key in obj) {
        keys.push(key);
      }
      return keys;
    };
    const deepEqual = function(actual, expected) {
      if (actual === expected) {
        return true;
      } else if (actual instanceof Date && expected instanceof Date) {
        return actual.getTime() === expected.getTime();
      } else if (typeof actual != "object" && typeof expected != "object") {
        return actual == expected;
      } else {
        return objEquiv(actual, expected);
      }
    };
    function isUndefinedOrNull(value) {
      return value === null || value === void 0;
    }
    function isArguments(object) {
      return Object.prototype.toString.call(object) == "[object Arguments]";
    }
    function objEquiv(a2, b2) {
      if (isUndefinedOrNull(a2) || isUndefinedOrNull(b2)) {
        return false;
      }
      if (a2.prototype !== b2.prototype) {
        return false;
      }
      if (isArguments(a2)) {
        if (!isArguments(b2)) {
          return false;
        }
        a2 = pSlice.call(a2);
        b2 = pSlice.call(b2);
        return deepEqual(a2, b2);
      }
      let ka, kb, key, i;
      try {
        ka = Object_keys(a2);
        kb = Object_keys(b2);
      } catch (e) {
        return false;
      }
      if (ka.length != kb.length) {
        return false;
      }
      ka.sort();
      kb.sort();
      for (i = ka.length - 1; i >= 0; i--) {
        if (ka[i] != kb[i]) {
          return false;
        }
      }
      for (i = ka.length - 1; i >= 0; i--) {
        key = ka[i];
        if (compare3) {
          let result = compare3(a2[key], b2[key], key);
          if (result === void 0) {
            result = isEqualWith(a2[key], b2[key]);
          }
          if (!result) {
            return false;
          }
        } else {
          if (!deepEqual(a2[key], b2[key])) {
            return false;
          }
        }
      }
      return true;
    }
    return deepEqual(a, b);
  }
  function get(obj, path, defaultValue = void 0) {
    const travel = (regexp) => String.prototype.split.call(path, regexp).filter(Boolean).reduce((res, key) => res !== null && res !== void 0 ? res[key] : res, obj);
    const result = travel(/[,[\]]+?/) || travel(/[,[\].]+?/);
    return result === void 0 || result === obj ? defaultValue : result;
  }
  function pick(object, keys) {
    return keys.reduce((obj, key) => {
      if (object && object.hasOwnProperty(key)) {
        obj[key] = object[key];
      }
      return obj;
    }, {});
  }
  function forOwn(object, cb) {
    for (let key in object) {
      if (object.hasOwnProperty(key)) {
        cb(object[key], key);
      }
    }
  }
  function isObject(object) {
    return typeof object === "object" && object !== null;
  }
  function isString(str) {
    return str && typeof str.valueOf() === "string" ? true : false;
  }
  function union(a, b) {
    return [.../* @__PURE__ */ new Set([...a, ...b])];
  }
  function unionWith(a, b, compare3) {
    return [...a, ...b].reduce((p, c) => {
      if (p.findIndex((v) => compare3(v, c)) !== -1) {
        return p;
      }
      p.push(c);
      return p;
    }, []);
  }
  function omitMod(obj, paths) {
    for (let path of paths) {
      if (typeof path === "string") {
        path = path.split(".");
      }
      for (let i = 0; i < path.length - 1; i++) {
        obj = obj[path[i]];
        if (typeof obj === "undefined") {
          continue;
        }
      }
      delete obj[path.pop()];
    }
  }

  // src/mapping-types.js
  var mapping_types_default = [
    {
      "RELEVANCE": "very high",
      "broader": [
        {
          "uri": "http://www.w3.org/2004/02/skos/core#closeMatch"
        }
      ],
      "definition": {
        "de": [
          "gleiche Bedeutung"
        ],
        "en": [
          "same meaning"
        ]
      },
      "notation": [
        "="
      ],
      "prefLabel": {
        "ar": "\u062A\u0637\u0627\u0628\u0642 \u062A\u0627\u0645",
        "be": "\u0434\u0430\u043A\u043B\u0430\u0434\u043D\u0430\u044F \u0430\u0434\u043F\u0430\u0432\u0435\u0434\u043D\u0430\u0441\u0446\u044C",
        "be-tarask": "\u0434\u0430\u043A\u043B\u0430\u0434\u043D\u0430\u044F \u0430\u0434\u043F\u0430\u0432\u0435\u0434\u043D\u0430\u0441\u044C\u0446\u044C",
        "bn": "\u09B9\u09C1\u09AC\u09C1\u09B9\u09C1 \u09AE\u09BF\u09B2",
        "bs": "ta\u010Dno podudaranje",
        "ca": "equival\xE8ncia exacta",
        "cs": "p\u0159esn\xE1 shoda",
        "da": "exact match",
        "de": "exakte \xDCbereinstimmung",
        "el": "\u03B1\u03BA\u03C1\u03B9\u03B2\u03AE\u03C2 \u03B1\u03BD\u03C4\u03B9\u03C3\u03C4\u03BF\u03B9\u03C7\u03AF\u03B1",
        "en": "exact match",
        "eo": "ekzakta ekvivalento",
        "es": "equivalencia exacta",
        "et": "t\xE4pne vaste",
        "fi": "vastaava k\xE4site",
        "fr": "\xE9quivalence exacte",
        "ga": "meaitse\xE1il chruinn",
        "gl": "correspondencia exacta",
        "he": "\u05D4\u05EA\u05D0\u05DE\u05D4 \u05DE\u05D3\u05D5\u05D9\u05E7\u05EA",
        "hu": "pontos egyez\xE9s",
        "id": "sama persis",
        "it": "corrispondenza esatta",
        "ja": "\u5B8C\u5168\u4E00\u81F4",
        "lv": "tie\u0161a sakrit\u012Bba",
        "mk": "\u0442\u043E\u0447\u043D\u043E \u0441\u043E\u0432\u043F\u0430\u0453\u0430\u045A\u0435",
        "ms": "padanan tepat",
        "ms-arab": "\u06A4\u0627\u062F\u0646\u0646 \u062A\u06A4\u062A",
        "nb": "eksakt samsvar",
        "nl": "exacte match",
        "nn": "eksakt samsvar",
        "pl": "dok\u0142adne dopasowanie",
        "pt": "correspond\xEAncia exata",
        "ro": "echivalentul exact",
        "ru": "\u0442\u043E\u0447\u043D\u043E\u0435 \u0441\u043E\u043E\u0442\u0432\u0435\u0442\u0441\u0442\u0432\u0438\u0435",
        "sl": "natan\u010Dno ujemanje",
        "sq": "p\xEBrputhje e p\xEBrpikt\xEB",
        "sr": "\u0442\u0430\u0447\u043D\u043E \u043F\u043E\u0434\u0443\u0434\u0430\u0440\u0430\u045A\u0435",
        "sv": "exakt tr\xE4ff",
        "tr": "tam e\u015Fle\u015Fme",
        "uk": "\u0442\u043E\u0447\u043D\u0430 \u0432\u0456\u0434\u043F\u043E\u0432\u0456\u0434\u043D\u0456\u0441\u0442\u044C",
        "ur": "\u0628\u0627\u0644\u06A9\u0644 \u062F\u0631\u0633\u062A \u062C\u0648\u0691",
        "zh": "\u7CBE\u78BA\u5339\u914D",
        "zh-cn": "\u7CBE\u786E\u5339\u914D",
        "zh-hans": "\u7CBE\u786E\u5339\u914D",
        "zh-hant": "\u7CBE\u78BA\u5339\u914D"
      },
      "SHORT": "exact",
      "uri": "http://www.w3.org/2004/02/skos/core#exactMatch"
    },
    {
      "RELEVANCE": "high",
      "broader": [
        {
          "uri": "http://www.w3.org/2004/02/skos/core#mappingRelation"
        }
      ],
      "definition": {
        "de": [
          "in etwa gleiche Bedeutung"
        ],
        "en": [
          "same general idea but not fully identical meaning"
        ]
      },
      "notation": [
        "\u2248"
      ],
      "prefLabel": {
        "ar": "\u062A\u0637\u0627\u0628\u0642 \u0642\u0631\u064A\u0628",
        "be-tarask": "\u0431\u043B\u0456\u0437\u043A\u0430\u044F \u0430\u0434\u043F\u0430\u0432\u0435\u0434\u043D\u0430\u0441\u044C\u0446\u044C",
        "ca": "equival\xE8ncia inexacta",
        "de": "hohe \xDCbereinstimmung",
        "el": "\u03C3\u03C4\u03B5\u03BD\u03AE \u03B1\u03BD\u03C4\u03B9\u03C3\u03C4\u03BF\u03B9\u03C7\u03AF\u03B1",
        "en": "close match",
        "eo": "proksima kongrua\u0135o",
        "es": "equivalencia inexacta",
        "fi": "l\xE4hes vastaava k\xE4site",
        "fr": "quasi-\xE9quivalence",
        "he": "\u05D4\u05EA\u05D0\u05DE\u05D4 \u05E7\u05E8\u05D5\u05D1\u05D4",
        "hu": "kv\xE1zi-egyen\xE9rt\xE9k\u0171s\xE9g",
        "it": "corrispondenza parziale",
        "ja": "\u985E\u4F3C\u4E00\u81F4",
        "mk": "\u0431\u043B\u0438\u0441\u043A\u043E \u0441\u043E\u0432\u043F\u0430\u0453\u0430\u045A\u0435",
        "ms": "padanan dekat",
        "ms-arab": "\u06A4\u0627\u062F\u0646\u0646 \u062F\u06A9\u062A",
        "nb": "n\xE6rt samsvar",
        "nl": "nabije match",
        "nn": "n\xE6rt samsvar",
        "pl": "cz\u0119\u015Bciowe dopasowanie",
        "pt": "correspond\xEAncia pr\xF3xima",
        "ru": "\u0431\u043B\u0438\u0437\u043A\u043E\u0435 \u0441\u043E\u043E\u0442\u0432\u0435\u0442\u0441\u0442\u0432\u0438\u0435",
        "sl": "visoko ujemanje",
        "sr": "\u0431\u043B\u0438\u0441\u043A\u043E \u043F\u043E\u043A\u043B\u0430\u043F\u0430\u045A\u0435",
        "sv": "n\xE4ra matchning",
        "tr": "yak\u0131n e\u015Fle\u015Fme",
        "zh-hans": "\u9AD8\u5EA6\u5339\u914D"
      },
      "SHORT": "close",
      "uri": "http://www.w3.org/2004/02/skos/core#closeMatch"
    },
    {
      "RELEVANCE": "medium",
      "broader": [
        {
          "uri": "http://www.w3.org/2004/02/skos/core#mappingRelation"
        }
      ],
      "definition": {
        "de": [
          "umfassendere Bedeutung"
        ],
        "en": [
          "broader meaning"
        ]
      },
      "notation": [
        ">"
      ],
      "prefLabel": {
        "be-tarask": "\u0448\u044B\u0440\u043E\u043A\u0430\u044F \u0430\u0434\u043F\u0430\u0432\u0435\u0434\u043D\u0430\u0441\u044C\u0446\u044C",
        "ca": "relaci\xF3 llunyana",
        "cs": "\u0161ir\u0161\xED koncept",
        "de": "allgemeinere Bedeutung",
        "en": "broad match",
        "eo": "malstrikta kongruo",
        "et": "laiem vaste",
        "fi": "vastaava laajempi k\xE4site",
        "he": "\u05D4\u05EA\u05D0\u05DE\u05D4 \u05E8\u05D7\u05D1\u05D4",
        "hu": "t\xE1gabb jelent\xE9s",
        "it": "corrispondenza con termine pi\xF9 generico",
        "ja": "\u5E83\u7FA9\u4E00\u81F4",
        "mk": "\u043F\u043E\u0448\u0438\u0440\u043E\u043A\u043E \u0441\u043E\u0432\u043F\u0430\u0453\u0430\u045A\u0435",
        "nb": "bredere samsvar",
        "nl": "brede match",
        "nn": "breitt samsvar",
        "pl": "dopasowanie poj\u0119cia o szerszym znaczeniu",
        "pt-br": "correspond\xEAncia gen\xE9rica",
        "ru": "\u0431\u043E\u043B\u0435\u0435 \u0448\u0438\u0440\u043E\u043A\u043E\u0435 \u0441\u043E\u043E\u0442\u0432\u0435\u0442\u0441\u0442\u0432\u0438\u0435",
        "sl": "splo\u0161ni pomen",
        "sr": "\u0443 \u0448\u0438\u0440\u0435\u043C \u0441\u043C\u0438\u0441\u043B\u0443",
        "sv": "bred tr\xE4ff",
        "uk": "\u0448\u0438\u0440\u0448\u0430 \u0432\u0456\u0434\u043F\u043E\u0432\u0456\u0434\u043D\u0456\u0441\u0442\u044C",
        "vi": "\u0111\u1ED1i s\xE1nh r\u1ED9ng",
        "zh-hans": "\u5E7F\u6CDB\u5339\u914D"
      },
      "related": [
        {
          "uri": "http://www.w3.org/2004/02/skos/core#narrowMatch"
        }
      ],
      "SHORT": "broad",
      "uri": "http://www.w3.org/2004/02/skos/core#broadMatch"
    },
    {
      "RELEVANCE": "medium",
      "broader": [
        {
          "uri": "http://www.w3.org/2004/02/skos/core#mappingRelation"
        }
      ],
      "definition": {
        "en": [
          "more specific meaning"
        ]
      },
      "notation": [
        "<"
      ],
      "prefLabel": {
        "be-tarask": "\u0432\u0443\u0437\u043A\u0430\u044F \u0430\u0434\u043F\u0430\u0432\u0435\u0434\u043D\u0430\u0441\u044C\u0446\u044C",
        "ca": "relaci\xF3 estreta",
        "de": "spezifischere Bedeutung",
        "en": "narrow match",
        "eo": "strikta kongruo",
        "et": "kitsam vaste",
        "fi": "vastaava suppeampi k\xE4site",
        "he": "\u05D4\u05EA\u05D0\u05DE\u05D4 \u05E6\u05E8\u05D4",
        "hu": "sz\u0171kebb jelent\xE9s",
        "it": "corrispondenza con termine pi\xF9 specifico",
        "ja": "\u72ED\u7FA9\u4E00\u81F4",
        "mk": "\u043F\u043E\u0442\u0435\u0441\u043D\u043E \u0441\u043E\u0432\u043F\u0430\u0453\u0430\u045A\u0435",
        "nb": "smalere samsvar",
        "nl": "nauwe match",
        "nn": "snevert samsvar",
        "pl": "dopasowanie poj\u0119cia o w\u0119\u017Cszym znaczeniu",
        "pt-br": "correspond\xEAncia aproximada",
        "ru": "\u0431\u043E\u043B\u0435\u0435 \u0443\u0437\u043A\u043E\u0435 \u0441\u043E\u043E\u0442\u0432\u0435\u0442\u0441\u0442\u0432\u0438\u0435",
        "sl": "ozki pomen",
        "sr": "\u0443 \u0443\u0436\u0435\u043C \u0441\u043C\u0438\u0441\u043B\u0443",
        "sv": "smal tr\xE4ff",
        "ur": "\u0646\u06CC\u0631\u0648 \u0645\u06CC\u0686",
        "vi": "\u0111\u1ED1i s\xE1nh h\u1EB9p",
        "zh-hans": "\u6709\u9650\u5339\u914D"
      },
      "related": [
        {
          "uri": "http://www.w3.org/2004/02/skos/core#broadMatch"
        }
      ],
      "SHORT": "narrow",
      "uri": "http://www.w3.org/2004/02/skos/core#narrowMatch"
    },
    {
      "RELEVANCE": "low",
      "broader": [
        {
          "uri": "http://www.w3.org/2004/02/skos/core#mappingRelation"
        }
      ],
      "definition": {
        "de": [
          "assoziative Verkn\xFCpfung unterschiedlicher Bedeutungen"
        ],
        "en": [
          "associative link between meanings"
        ]
      },
      "notation": [
        "~"
      ],
      "prefLabel": {
        "be-tarask": "\u0437\u044C\u0432\u044F\u0437\u0430\u043D\u0430\u044F \u0430\u0434\u043F\u0430\u0432\u0435\u0434\u043D\u0430\u0441\u044C\u0446\u044C",
        "ca": "parella relacionada",
        "de": "verwandte Bedeutung",
        "en": "related match",
        "eo": "rilata kongruo",
        "fi": "liittyv\xE4 k\xE4site",
        "fr": "association",
        "he": "\u05D4\u05EA\u05D0\u05DE\u05D4 \u05E7\u05E9\u05D5\u05E8\u05D4",
        "hu": "rokon jelent\xE9s",
        "it": "corrispondenza correlata",
        "ja": "\u95A2\u9023\u4E00\u81F4",
        "lv": "saist\u012Bta sakrit\u012Bba",
        "mk": "\u043F\u043E\u0432\u0440\u0437\u0430\u043D\u043E \u0441\u043E\u0432\u043F\u0430\u0453\u0430\u045A\u0435",
        "ms": "padanan berkaitan",
        "ms-arab": "\u06A4\u0627\u062F\u0646\u0646 \u0628\u0631\u06A9\u0627\u0621\u064A\u062A\u0646",
        "nb": "relatert samsvar",
        "nl": "gerelateerde match",
        "pl": "dopasowanie poj\u0119cia o powi\u0105zanym znaczeniu",
        "ru": "\u0430\u0441\u0441\u043E\u0446\u0438\u0430\u0442\u0438\u0432\u043D\u043E\u0435 \u0441\u043E\u043E\u0442\u0432\u0435\u0442\u0441\u0442\u0432\u0438\u0435",
        "sl": "povezano ujemanje",
        "tr": "ili\u015Fkili benze\u015Fme",
        "uk": "\u043F\u043E\u0432\u2019\u044F\u0437\u044C",
        "ur": "\u0645\u062A\u0639\u0644\u0642\u06C1 \u0645\u06CC\u0686",
        "vec": "parente\u0142a re\u0142asionada",
        "zh-hans": "\u5173\u8054\u5339\u914D"
      },
      "SHORT": "related",
      "uri": "http://www.w3.org/2004/02/skos/core#relatedMatch"
    },
    {
      "RELEVANCE": "generic",
      "definition": {
        "de": [
          "unbekannter Bedeutungszusammenhang"
        ],
        "en": [
          "unknown type of link between meanings"
        ]
      },
      "notation": [
        "\u2192"
      ],
      "prefLabel": {
        "ar": "\u0646\u0648\u0639 \u0639\u0644\u0627\u0642\u0629 \u0627\u0644\u062A\u0637\u0628\u064A\u0642",
        "be": "\u0445\u0430\u0440\u0430\u043A\u0442\u044D\u0440\u043D\u0430\u044F \u0430\u0434\u043D\u043E\u0441\u0456\u043D\u0430 \u0430\u0434\u043B\u044E\u0441\u0442\u0440\u0430\u0432\u0430\u043D\u043D\u044F",
        "be-tarask": "\u0445\u0430\u0440\u0430\u043A\u0442\u044D\u0440\u043D\u0430\u044F \u0430\u0434\u043D\u043E\u0441\u0456\u043D\u0430 \u0430\u0434\u043B\u044E\u0441\u0442\u0440\u0430\u0432\u0430\u043D\u044C\u043D\u044F",
        "ca": "relaci\xF3 de mapatge",
        "de": "allgemeine Mapping-Relation",
        "en": "SKOS generic mapping relation",
        "fi": "SKOS-kartoitussuhde",
        "fr": "lien de correspondance SKOS",
        "he": "\u05D9\u05D7\u05E1 \u05DE\u05D9\u05E4\u05D5\u05D9 \u05DB\u05DC\u05DC\u05D9",
        "id": "relasi pemetaan",
        "ja": "SKOS\u4E00\u822C\u30DE\u30C3\u30D4\u30F3\u30B0\u95A2\u4FC2",
        "mk": "\u043F\u0440\u0435\u0441\u043B\u0438\u043A\u0443\u0432\u0430\u0447\u043A\u0438 \u043E\u0434\u043D\u043E\u0441",
        "nb": "SKOS generisk mappingrelasjon",
        "pt-br": "rela\xE7\xE3o gen\xE9rica de mapeamento",
        "sl": "splo\u0161na relacija kartiranja SKOS",
        "sr": "\u0440\u0435\u043B\u0430\u0446\u0438\u0458\u0430 \u043C\u0430\u043F\u0438\u0440\u0430\u045A\u0430",
        "sv": "mappnings relation",
        "zh": "\u6620\u5C04\u95DC\u4FC2",
        "zh-hant": "\u6620\u5C04\u95DC\u4FC2"
      },
      "SHORT": "",
      "uri": "http://www.w3.org/2004/02/skos/core#mappingRelation"
    }
  ];

  // src/object-types.js
  var objectTypes = {
    Concept: {
      type: ["http://www.w3.org/2004/02/skos/core#Concept"]
    },
    ConceptScheme: {
      type: ["http://www.w3.org/2004/02/skos/core#ConceptScheme"]
    },
    ConceptMapping: {
      type: mapping_types_default.map((type) => type.uri)
    },
    ConceptOccurrence: {
      type: [
        "http://purl.org/cld/cdtype/CatalogueOrIndex"
      ]
    },
    Registry: {
      type: [
        "http://www.w3.org/ns/dcat#Catalog"
      ]
    },
    Distribution: {
      type: [
        "http://www.w3.org/ns/dcat#Distribution"
      ]
    },
    Concordance: {
      type: [
        "http://rdfs.org/ns/void#Linkset",
        "http://rdf-vocabulary.ddialliance.org/xkos#Correspondence"
      ]
    },
    Resource: {},
    Item: {},
    ConceptBundle: {},
    Annotation: {
      type: [
        "Annotation",
        "http://www.w3.org/ns/oa#Annotation"
      ]
    }
  };
  var objectTypeUris = Object.keys(objectTypes).reduce((map, name) => {
    for (let uri of objectTypes[name].type || []) {
      map[uri] = name;
    }
    return map;
  }, {});
  function guessObjectType(obj, shortname = false) {
    let type;
    if (typeof obj === "string" && obj) {
      if (obj in objectTypeUris) {
        type = objectTypeUris[obj];
      } else {
        obj = obj.toLowerCase().replace(/s$/, "");
        type = Object.keys(objectTypes).find((name) => {
          const lowercase = name.toLowerCase();
          if (lowercase === obj || lowercase === "concept" + obj) {
            return true;
          }
        });
      }
    } else if (typeof obj === "object") {
      if (obj.type) {
        let types = Array.isArray(obj.type) ? obj.type : [obj.type];
        for (let uri of types) {
          if (uri in objectTypeUris) {
            type = objectTypeUris[uri];
            break;
          }
        }
      }
    }
    return shortname && type ? type.toLowerCase().replace(/^concept(.+)/, "$1") : type;
  }

  // src/concept-scheme.js
  var regexChars = /[\\^$.*+?()[\]{}|]/g;
  var regexEscape = (string) => string.replace(regexChars, "\\$&");
  var notationEscapeChars = /[%ÄÖÜäöü ]/g;
  var ConceptScheme = class {
    /**
     * @param {object} [jskos] - object that's copied as scheme (shallow copy)
     */
    constructor(scheme = {}) {
      Object.assign(this, scheme);
      if (!this.notationPattern) {
        this.notationPattern = ".+";
      }
      if (!this.uriPattern && this.namespace) {
        this.uriPattern = "^" + regexEscape(this.namespace);
        const escaped = this.notationPattern.replace(notationEscapeChars, encodeURI);
        this.uriPattern += "(" + escaped + ")$";
      }
      this.NOTATION_REGEX = RegExp("^(" + this.notationPattern + ")$");
      if (this.uriPattern) {
        this.URI_REGEX = RegExp(this.uriPattern);
      }
    }
    /**
     * Check whether a string is a valid notation as defined by `notationPattern`.
     * @param {string} notation
     * @returns {array|null}
     */
    isValidNotation(notation2) {
      return this.NOTATION_REGEX.exec(notation2);
    }
    /**
     * Check whether URI belongs to the scheme, return local notation on success.
     * Requires scheme to have `uriPattern` or `namespace`.
     * @param {string} uri
     * @returns {string|undefined}
     */
    notationFromUri(uri) {
      if (this.URI_REGEX) {
        const match = this.URI_REGEX.exec(uri);
        if (match) {
          return decodeURI(match[1]);
        }
      }
    }
    /**
     * Map local notation to URI. Does not check whether notation is valid!
     * Requires scheme to have `uriPattern` or `namespace`.
     * @param {string} notation
     * @example scheme.uriFromNotation("123") // http://example.org/123
     */
    uriFromNotation(notation2) {
      if (this.uriPattern) {
        notation2 = encodeURIComponent(notation2);
        return this.uriPattern.replace(/^\^|\$$/g, "").replace(/\\/g, "").replace(/\(.*\)/, notation2);
      }
    }
    /**
     * Check whether URI belongs to the scheme, return concept on success.
     * Requires scheme to have `uriPattern` or `namespace`.
     * @param {string} uri
     * @param {object} [options] boolean flags `inScheme` and `toConcept`
     */
    conceptFromUri(uri, options = {}) {
      const notation2 = this.notationFromUri(uri);
      if (notation2 === void 0) {
        return;
      }
      const concept = { uri, notation: [notation2] };
      if (options.inScheme) {
        concept.inScheme = [{ uri: this.uri }];
      }
      if (options.topConcept) {
        concept.topConceptOf = [{ uri: this.uri }];
      }
      return concept;
    }
    /**
     * Map local notation to concept, if notation is valid. Requires scheme to
     * have `uriPattern` or `namespace`.
     * @param {string} notation
     * @param {object} [options] same as conceptFromUri options
     */
    conceptFromNotation(notation2, options) {
      if (this.isValidNotation(notation2)) {
        return this.conceptFromUri(this.uriFromNotation(notation2), options);
      }
    }
  };
  var concept_scheme_default = ConceptScheme;

  // src/language-preference.js
  var languagePreference = {
    store: null,
    path: "",
    defaults: ["en"],
    getLanguages,
    selectLanguage
  };
  function getLanguages() {
    return get(languagePreference.store, languagePreference.path) || languagePreference.defaults;
  }
  function selectLanguage(languageMap) {
    if (!languageMap) {
      return null;
    }
    for (let language of getLanguages()) {
      if (languageMap[language]) {
        return language;
      }
    }
    for (let language of Object.keys(languageMap)) {
      if (language != "-") {
        return language;
      }
    }
    return null;
  }
  var language_preference_default = languagePreference;

  // src/tools.js
  var isUpperCase = (str) => {
    return /^[A-Z]*$/.test(str);
  };
  var getNested = (object, path) => {
    return path.split(".").reduce(
      (xs, x) => xs && xs[x] ? xs[x] : null,
      object
    );
  };
  var addContext = (jskos) => {
    let array = jskos instanceof Array ? jskos : [jskos];
    array.forEach((resource) => {
      resource["@context"] = "https://gbv.github.io/jskos/context.json";
    });
    return jskos;
  };
  var clean = (jskos) => {
    Object.keys(jskos).forEach((key) => {
      if (isUpperCase(key) || key.startsWith("_")) {
        delete jskos[key];
      } else {
        if (jskos[key] != null && typeof jskos[key] === "object") {
          jskos[key] = clean(jskos[key]);
        }
      }
    });
    return jskos;
  };
  var cleanJSKOS = clean;
  var copyDeep = (object, replaceCircular = [], skipUnderscore = true) => {
    replaceCircular = replaceCircular.concat([
      "ancestors",
      "narrower",
      "broader",
      "mappings",
      "memberList",
      "TOPCONCEPTS",
      "MAPPINGS",
      "PROVIDER"
    ]);
    let clone = Array.isArray(object) ? [] : {};
    for (let i in object) {
      if (skipUnderscore && i[0] == "_") {
        continue;
      }
      if (replaceCircular.includes(i)) {
        if (object[i] && Array.isArray(object[i])) {
          if (object[i].length > 0) {
            clone[i] = [null];
          } else {
            clone[i] = [];
          }
          continue;
        } else {
          clone[i] = null;
          continue;
        }
      }
      if (i == "inScheme") {
        let inScheme = [];
        for (let scheme of object.inScheme) {
          let newScheme = { uri: scheme.uri };
          if (scheme.notation) {
            newScheme.notation = scheme.notation;
          }
          if (scheme.prefLabel) {
            newScheme.prefLabel = scheme.prefLabel;
          }
          inScheme.push(newScheme);
        }
        clone.inScheme = inScheme;
        continue;
      }
      if (object[i] != null && typeof object[i] == "object") {
        clone[i] = copyDeep(object[i]);
      } else {
        clone[i] = object[i];
      }
    }
    return clone;
  };
  var deepCopy = copyDeep;
  var getAllUris = (object) => {
    if (!object) {
      return [];
    }
    return (object.uri ? [object.uri] : []).concat(object.identifier || []).filter(Boolean);
  };
  var compare2 = (object1, object2) => {
    if (object1 == null && object2 == null) {
      return true;
    }
    const replaceUri = (uri) => uri.replace("https://", "http://");
    const object1uris = getAllUris(object1).map(replaceUri);
    for (let uri of getAllUris(object2).map(replaceUri)) {
      if (object1uris.indexOf(uri) !== -1) {
        return true;
      }
    }
    return false;
  };
  var compareObjects = compare2;
  var compareSchemes = compare2;
  var compareConcepts = compare2;
  var isConcept = (object) => {
    var _a;
    return ((_a = get(object, "type", [])) == null ? void 0 : _a.includes("http://www.w3.org/2004/02/skos/core#Concept")) || get(object, "inScheme") != null || get(object, "topConceptOf") != null;
  };
  var isScheme = (object) => {
    var _a;
    return (_a = get(object, "type", [])) == null ? void 0 : _a.includes("http://www.w3.org/2004/02/skos/core#ConceptScheme");
  };
  var isContainedIn = (object, objects) => {
    if (!object || !objects) {
      return false;
    }
    for (let o of objects) {
      if (compare2(object, o)) {
        return true;
      }
    }
    return false;
  };
  var isSchemeInList = isContainedIn;
  var sortConcepts = (concepts, numerical = false) => {
    return concepts.sort(
      (a, b) => {
        let _a = get(a, "notation[0]"), _b = get(b, "notation[0]");
        if (_a && _b) {
          _a = _a.toLowerCase();
          _b = _b.toLowerCase();
        }
        if (numerical && _a && _b) {
          let __a, __b;
          __a = parseFloat(_a);
          __b = parseFloat(_b);
          if (!__a && !__b) {
            const _a_split = `${_a}`.split(/[^\w\d]/);
            const _b_split = `${_b}`.split(/[^\w\d]/);
            for (let i = 0; i < Math.min(_a_split.length, _b_split.length); i += 1) {
              if (_a_split[i] !== _b_split[i]) {
                __a = parseFloat(_a_split[i]) || _a_split[i];
                __b = parseFloat(_b_split[i]) || _b_split[i];
                break;
              }
            }
            if (!__a && !__b) {
              __a = _a;
              __b = _b;
            }
          }
          _a = __a;
          _b = __b;
        }
        if (!_a || !_b || _a == _b) {
          _a = a.uri;
          _b = b.uri;
        }
        if (_a && _b) {
          if (_a > _b) {
            return 1;
          } else if (_a < _b) {
            return -1;
          }
        }
        return 0;
      }
    );
  };
  var sortSchemes = (schemes) => {
    let order = ["notation[0]", ["prefLabel.de", "prefLabel.en"], "uri"];
    return schemes.sort(
      (a, b) => {
        for (let path of order) {
          let _a, _b;
          if (Array.isArray(path)) {
            for (let path2 of path) {
              _a = _a || get(a, path2);
              _b = _b || get(b, path2);
            }
          } else {
            _a = get(a, path);
            _b = get(b, path);
          }
          if (_a != null && _b != null) {
            _a = _a.toLowerCase();
            _b = _b.toLowerCase();
            if (_a > _b) {
              return 1;
            } else if (_a < _b) {
              return -1;
            }
          }
        }
        return 0;
      }
    );
  };
  var minifyMapping = (mapping) => {
    let newMapping = pick(copyDeep(mapping), ["from", "to", "fromScheme", "toScheme", "creator", "contributor", "type", "created", "modified", "note", "identifier", "uri", "partOf", "mappingRelevance"]);
    for (let fromTo of [newMapping.from, newMapping.to]) {
      forOwn(fromTo, (value, key) => {
        let conceptBundle = [];
        for (let concept of value) {
          conceptBundle.push(pick(concept, ["uri", "notation"]));
        }
        fromTo[key] = conceptBundle;
      });
    }
    if (newMapping.fromScheme) {
      newMapping.fromScheme = pick(newMapping.fromScheme, ["uri", "notation"]);
    }
    if (newMapping.toScheme) {
      newMapping.toScheme = pick(newMapping.toScheme, ["uri", "notation"]);
    }
    if (newMapping.partOf) {
      newMapping.partOf = newMapping.partOf.map((c) => pick(c, ["uri"]));
    }
    return newMapping;
  };
  var mappingTypeByUri = function(uri) {
    for (let mappingType of mapping_types_default) {
      if (uri == mappingType.uri) {
        return mappingType;
      }
    }
    return null;
  };
  var defaultMappingType = mappingTypeByUri("http://www.w3.org/2004/02/skos/core#mappingRelation");
  var mappingTypeByType = function(type, defaultType = defaultMappingType) {
    let uri;
    if (Array.isArray(type) && type.length > 0) {
      uri = type[0];
    } else {
      uri = type;
    }
    return mappingTypeByUri(uri) || defaultType;
  };
  var flattenMapping = (mapping, options = {}) => {
    const { language } = options;
    let fromNotation = getNested(mapping, "from.memberSet.0.notation.0");
    let toNotation = getNested(mapping, "to.memberSet.0.notation.0");
    fromNotation = fromNotation !== null ? fromNotation : "";
    toNotation = toNotation !== null ? toNotation : "";
    let type = mappingTypeByUri(getNested(mapping, "type.0"));
    type = type ? type.SHORT : "";
    let fromLabel = prefLabel(getNested(mapping, "from.memberSet.0"), { language, fallbackToUri: false }) || "";
    let toLabel = prefLabel(getNested(mapping, "to.memberSet.0"), { language, fallbackToUri: false }) || "";
    let creator = prefLabel(getNested(mapping, "creator.0"), { language, fallbackToUri: false }) || "";
    return { fromNotation, toNotation, fromLabel, toLabel, type, creator };
  };
  var csvSerializer = (options = {}) => {
    const delimiter = options.delimiter || ",";
    const quoteChar = options.quoteChar || '"';
    const lineTerminator = options.lineTerminator || "\n";
    const doubleQuote = quoteChar + quoteChar;
    const quote = (s) => quoteChar + (s == null ? "" : s.split(quoteChar).join(doubleQuote)) + quoteChar;
    return (row) => row.map(quote).join(delimiter) + lineTerminator;
  };
  var conceptsOfMapping = (mapping, side) => {
    let concepts = [];
    for (let s of ["from", "to"]) {
      if (side == null || s === side) {
        concepts = concepts.concat(
          get(mapping, `${s}.memberSet`) || get(mapping, `${s}.memberChoice`) || get(mapping, `${s}.memberList`) || []
        );
      }
    }
    return concepts.filter((c) => c != null);
  };
  var mappingCSV = (options = {}) => {
    const toCSV = csvSerializer(options);
    const language = options.language || "en";
    if (options.type == null) {
      options.type = true;
    }
    const header = (mappings) => {
      mappings = mappings || [];
      let fields = [];
      for (let side of ["from", "to"]) {
        if (options.schemes) {
          fields.push(`${side}Scheme`);
        }
        let conceptCount = Math.max(...mappings.map((mapping) => conceptsOfMapping(mapping, side).length), 1);
        for (let i = 0; i < conceptCount; i += 1) {
          fields.push(`${side}Notation${i ? i + 1 : ""}`);
          if (options.labels) {
            fields.push(`${side}Label${i ? i + 1 : ""}`);
          }
        }
      }
      if (options.type) {
        fields.push("type");
      }
      if (options.creator) {
        fields.push("creator");
      }
      return toCSV(fields);
    };
    const fromMapping = (mapping, options2 = {}) => {
      let fields = [];
      for (let side of ["from", "to"]) {
        if (options.schemes) {
          fields.push(get(mapping, `${side}Scheme.notation[0]`, ""));
        }
        const concepts = conceptsOfMapping(mapping, side);
        let conceptCount = options2[`${side}Count`];
        if (conceptCount == null) {
          conceptCount = concepts.length;
        }
        conceptCount = Math.max(conceptCount, 1);
        for (let i = 0; i < conceptCount; i += 1) {
          fields.push(get(concepts[i], "notation[0]", ""));
          if (options.labels) {
            fields.push(prefLabel(concepts[i], { language, fallbackToUri: false }));
          }
        }
      }
      if (options.type) {
        fields.push(get(mappingTypeByUri(get(mapping, "type[0]")), "SHORT", ""));
      }
      if (options.creator) {
        fields.push(prefLabel(get(mapping, "creator[0]"), { language, fallbackToUri: false }));
      }
      return toCSV(fields);
    };
    const fromMappings = (mappings, options2 = { header: true }) => {
      let result = "";
      if (options2.header) {
        result += header(mappings);
      }
      const fromMappingOptions = {
        fromCount: Math.max(...mappings.map((mapping) => conceptsOfMapping(mapping, "from").length)),
        toCount: Math.max(...mappings.map((mapping) => conceptsOfMapping(mapping, "to").length))
      };
      for (let mapping of mappings) {
        result += fromMapping(mapping, fromMappingOptions);
      }
      return result;
    };
    return {
      header,
      fromMapping,
      fromMappings
    };
  };
  function compareMappingsDeep(mapping1, mapping2) {
    return isEqualWith(mapping1, mapping2, (object1, object2, prop) => {
      let mapping12 = { [prop]: object1 };
      let mapping22 = { [prop]: object2 };
      if (prop == "from" || prop == "to") {
        if (!isEqualWith(Object.getOwnPropertyNames(get(object1, prop, {})), Object.getOwnPropertyNames(get(object2, prop, {})))) {
          return false;
        }
        return isEqualWith(conceptsOfMapping(mapping12, prop), conceptsOfMapping(mapping22, prop), (concept1, concept2, index) => {
          if (index != void 0) {
            return compare2(concept1, concept2);
          }
          return void 0;
        });
      }
      if (prop == "fromScheme" || prop == "toScheme") {
        return compare2(object1, object2);
      }
      return void 0;
    });
  }
  var matchObjectTypes = (a, b) => {
    let aType = guessObjectType(a), bType = guessObjectType(b);
    if (aType && bType && aType != bType) {
      return false;
    }
    return true;
  };
  var _nullSort = (array) => {
    if (Array.isArray(array)) {
      array.sort((a, b) => {
        if (a === null) {
          return 1;
        }
        if (b === null) {
          return -1;
        }
        return 0;
      });
    }
  };
  var mergeUris = (a, b) => {
    if (!a || !b) {
      return a;
    }
    if (Array.isArray(a.identifier) || Array.isArray(b.identifier)) {
      a.identifier = union(a.identifier || [], b.identifier || []);
    }
    if (!a.uri && b.uri) {
      a.uri = b.uri;
    }
    if (a.uri && b.uri && a.uri != b.uri && !(a.identifier || []).includes(b.uri)) {
      a.identifier = (a.identifier || []).concat([b.uri]);
    }
    if (Array.isArray(a.identifier) && a.uri) {
      a.identifier = a.identifier.filter((uri) => uri !== a.uri);
    }
    if ((a.identifier || []).length == 0) {
      delete a.identifier;
    }
    _nullSort(a.identifier);
    return a;
  };
  var merge = (a, b, options) => {
    if (!a || !b) {
      return a ? a : b;
    }
    options = options || {};
    let path = options._path || "";
    let detectMismatch = options.detectMismatch || [];
    let skipPaths = options.skipPaths || [];
    let result = {};
    forOwn(a, (value, key) => {
      if (skipPaths.includes(path + key)) {
        return;
      }
      if (Array.isArray(value) && Array.isArray(b[key])) {
        result[key] = unionWith(value, b[key], (first, second) => {
          if (isObject(first) && isObject(second)) {
            return compare2(first, second);
          }
          return first === second;
        });
        _nullSort(result[key]);
      } else if (isObject(value) && isObject(b[key])) {
        result[key] = merge(value, b[key], Object.assign({ _path: `${path}${key}.` }, options));
      } else {
        if (value && b[key] && detectMismatch.includes(path + key) && !isEqualWith(value, b[key])) {
          throw new Error("Property mismatch in " + path + key);
        }
        result[key] = value;
      }
    });
    forOwn(b, (value, key) => {
      if (!a[key]) {
        result[key] = value;
      }
    });
    if (path == "") {
      omitMod(result, skipPaths);
    }
    if (options.mergeUris) {
      mergeUris(result, b);
    }
    return result;
  };
  var normalize = (data) => {
    if (Array.isArray(data)) {
      return data.map((element) => normalize(element));
    } else if (isObject(data)) {
      forOwn(data, (value, key) => {
        data[key] = normalize(value);
      });
      return data;
    } else {
      if (isString(data)) {
        return data.normalize();
      } else {
        return data;
      }
    }
  };
  var isValidUri = (uri) => {
    const re_js_rfc3986_URI = /^[A-Za-z][A-Za-z0-9+\-.]*:(?:\/\/(?:(?:[A-Za-z0-9\-._~!$&'()*+,;=:]|%[0-9A-Fa-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9A-Fa-f]{1,4}:){6}|::(?:[0-9A-Fa-f]{1,4}:){5}|(?:[0-9A-Fa-f]{1,4})?::(?:[0-9A-Fa-f]{1,4}:){4}|(?:(?:[0-9A-Fa-f]{1,4}:){0,1}[0-9A-Fa-f]{1,4})?::(?:[0-9A-Fa-f]{1,4}:){3}|(?:(?:[0-9A-Fa-f]{1,4}:){0,2}[0-9A-Fa-f]{1,4})?::(?:[0-9A-Fa-f]{1,4}:){2}|(?:(?:[0-9A-Fa-f]{1,4}:){0,3}[0-9A-Fa-f]{1,4})?::[0-9A-Fa-f]{1,4}:|(?:(?:[0-9A-Fa-f]{1,4}:){0,4}[0-9A-Fa-f]{1,4})?::)(?:[0-9A-Fa-f]{1,4}:[0-9A-Fa-f]{1,4}|(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?))|(?:(?:[0-9A-Fa-f]{1,4}:){0,5}[0-9A-Fa-f]{1,4})?::[0-9A-Fa-f]{1,4}|(?:(?:[0-9A-Fa-f]{1,4}:){0,6}[0-9A-Fa-f]{1,4})?::)|[Vv][0-9A-Fa-f]+\.[A-Za-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)|(?:[A-Za-z0-9\-._~!$&'()*+,;=]|%[0-9A-Fa-f]{2})*)(?::[0-9]*)?(?:\/(?:[A-Za-z0-9\-._~!$&'()*+,;=:@]|%[0-9A-Fa-f]{2})*)*|\/(?:(?:[A-Za-z0-9\-._~!$&'()*+,;=:@]|%[0-9A-Fa-f]{2})+(?:\/(?:[A-Za-z0-9\-._~!$&'()*+,;=:@]|%[0-9A-Fa-f]{2})*)*)?|(?:[A-Za-z0-9\-._~!$&'()*+,;=:@]|%[0-9A-Fa-f]{2})+(?:\/(?:[A-Za-z0-9\-._~!$&'()*+,;=:@]|%[0-9A-Fa-f]{2})*)*|)(?:\?(?:[A-Za-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9A-Fa-f]{2})*)?(?:#(?:[A-Za-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9A-Fa-f]{2})*)?$/;
    return uri.match(re_js_rfc3986_URI) !== null;
  };
  var compareFunctions = {
    /**
     * Compare mappings by their first concept.
     *
     * @param {*} mapping1 - first mapping
     * @param {*} mapping2 - second mapping
     * @param {*} fromTo - side, either `from` or `to`
     */
    mappingsByConcepts: (mapping1, mapping2, fromTo) => {
      let bundleFields = ["memberSet", "memberList", "memberChoice"], notation1, notation2;
      for (let field of bundleFields) {
        notation1 = notation1 || get(mapping1, fromTo + "." + field + "[0].notation[0]");
        notation2 = notation2 || get(mapping2, fromTo + "." + field + "[0].notation[0]");
      }
      if (notation1 == null || notation1 < notation2) {
        return -1;
      }
      if (notation2 == null || notation1 > notation2) {
        return 1;
      }
      return 0;
    }
  };
  var userOwnsMapping = (user, mapping) => {
    if (!user || !mapping) {
      return false;
    }
    return [user.uri].concat(Object.values(user.identities || {}).map((identity) => identity.uri)).filter((uri) => uri != null).includes(get(mapping, "creator[0].uri"));
  };
  function notation(item, type) {
    let notation2;
    if (item && item.notation && item.notation.length) {
      notation2 = item.notation[0];
      if (isScheme(item) || type == "scheme") {
        notation2 = notation2.toUpperCase();
      }
    } else if (item && item.inScheme && item.inScheme[0] && item.uri) {
      try {
        const scheme = new concept_scheme_default(item && item.inScheme && item.inScheme[0]);
        notation2 = scheme.notationFromUri(item.uri);
      } catch (error) {
      }
    }
    return notation2 || "";
  }
  function languageMapContent(item, prop, { language } = {}) {
    let languageMap = item && prop ? item[prop] : item;
    if (languageMap) {
      if (languageMap[language]) {
        return languageMap[language];
      }
      language = language_preference_default.selectLanguage(languageMap);
      if (language) {
        return languageMap[language];
      }
    }
    return null;
  }
  function prefLabel(item, options = {}) {
    options = options || {};
    const fallbackToUri = options.fallbackToUri == null ? true : options.fallbackToUri;
    return get(item, `prefLabel.${options.language}`) || languageMapContent(item, "prefLabel", options) || (fallbackToUri && item && item.uri ? item.uri : "");
  }
  function definition(item, options = {}) {
    options = options || {};
    let content = get(item, `definition.${options.language}`) || languageMapContent(item, "definition", options) || [];
    if (isString(content)) {
      content = [content];
    }
    return content;
  }
  function mappingRegistryIsStored(registry) {
    return get(registry, "stored", get(registry, "constructor.stored", get(registry, "provider.constructor.stored", false)));
  }
  function annotationCreatorUri(annotation) {
    if (isString(annotation.creator)) {
      return annotation.creator;
    }
    return annotation.creator && annotation.creator.id;
  }
  function annotationCreatorName(annotation) {
    return get(annotation, "creator.name") || "";
  }
  function annotationCreatorMatches(annotation, uris) {
    return !!(annotation && isString(annotation.creator) ? uris && uris.includes(annotation.creator) : uris && annotation.creator && uris.includes(annotation.creator.id));
  }
  function guessSchemeFromNotation(notation2, schemes) {
    return schemes.filter(({ notationPattern }) => {
      if ((notationPattern || ".+") === ".+") {
        return false;
      }
      return RegExp("^(" + notationPattern + ")$").test(notation2);
    });
  }

  // src/index.js
  var src_default = __spreadProps(__spreadValues(__spreadValues({}, identifiers_exports), tools_exports), {
    ConceptScheme: concept_scheme_default,
    languagePreference: language_preference_default
  });
  return __toCommonJS(src_exports);
})();
//# sourceMappingURL=jskos-tools.js.map
